grails-app/domain/org/grails/plugin/License.groovy
package org.grails.plugin

/**
 * Stores details of software licenses.
 */
class License {
    String name
    String url

    static constraints = {
        name blank: false
        url url: true
    }
    
    static mapping = {
        cache true
    }
}

grails-app/domain/org/grails/plugin/PendingRelease.groovy
package org.grails.plugin

import org.joda.time.DateTime

/**
 * Stores a plugin release in the database
 */ 
class PendingRelease {

    String pluginName
    String pluginVersion
    byte[] zip
    byte[] pom
    byte[] xml
    DateTime dateCreated
    ReleaseStatus status = ReleaseStatus.PENDING

    static constraints = {
        pluginName blank: false
        pluginVersion blank: false
        zip nullable: true, size:0..50000000 // ~50mb
        pom nullable: true, size:0..500000 // 500kb
        xml nullable: true, size:0..500000 // 500kb
    }
    
    static mapping = {
        cache false
    }

    String toString() { "$pluginName:$pluginVersion" }
}

enum ReleaseStatus {
    // Don't change the toString() representations of these as the public API
    // implemented by PendingReleaseController uses them.
    PENDING, COMPLETED, FAILED
}

grails-app/domain/org/grails/plugin/PluginPendingApproval.groovy
package org.grails.plugin

import org.grails.auth.User
import org.grails.common.ApprovalStatus
import org.grails.content.GenericApprovalResponse
import org.joda.time.DateTime
import org.joda.time.Days

class PluginPendingApproval {

    String name
    String versionNumber
    String scmUrl
    ApprovalStatus status = ApprovalStatus.PENDING
    User submittedBy
    String notes
    DateTime dateCreated

    static constraints = {
        name blank: false, unique: 'versionNumber', matches:/\S+/
        versionNumber blank: false
        scmUrl blank: false
        status blank: false
        notes nullable: true, blank: true
        submittedBy nullable: false
    }

    static mapping = {
        notes type: 'text'
        cache true
    }

    static namedQueries = {
        pending {
            eq('status', ApprovalStatus.PENDING)
        }
    }

    def setDisposition(GenericApprovalResponse genericApprovalResponse) {
        this.status = genericApprovalResponse.status
        this.save(flush: true)
    }

    List<GenericApprovalResponse> getGenericApprovalResponses() {
        def query = GenericApprovalResponse.where {
            whatType == this.class.name && whatId == this.id
        }
        return query.list(sort: 'id', order: 'asc')
    }

    def getIsNew() {
        (dateCreated > (new DateTime() - Days.days(14)))
    }

    String toString() {
        "PluginPendingApproval : $name ($id)"
    }
}

grails-app/domain/org/grails/plugin/PluginRelease.groovy
package org.grails.plugin

import org.joda.time.DateTime

/**
 * Models a plugin release
 *
 * @author Graeme Rocher
 */
class PluginRelease {
    DateTime releaseDate = new DateTime()
    String releaseVersion
    String downloadUrl
    boolean isSnapshot

    static belongsTo = [plugin:Plugin]
    
    static constraints = {
        releaseDate bindable:true, nullable:false
        releaseVersion blank:false
        downloadUrl blank:false
        isSnapshot()
    }

    static mapping = {
        cache true
        version false        
    }
}

grails-app/domain/org/grails/plugin/PluginTab.groovy
package org.grails.plugin

import org.grails.content.Content

/**
 * Domain class representing a plugin tab wiki page.
 */
class PluginTab extends Content {
    
    static transients = ['plugin']
    
    static searchable = {
        root false
        only = ['title', 'body']
    }
    
    static mapping = {
        cache 'nonstrict-read-write'
    }
    
    Plugin getPlugin() {
        return Plugin."findBy${capitalize(PluginService.extractTabName(title))}"(this)
    }
    
    private capitalize(str) {
        if (!str) return str
        return str[0].toUpperCase() + str[1..-1]
    }
}

grails-app/controllers/org/grails/ErrorController.groovy
package org.grails

import org.grails.plugin.PluginTab
import org.grails.wiki.WikiPage

class ErrorController {
    def wikiPageService
    
    private boolean hasWikiPage(String id) {
        def wikiPage = wikiPageService.getCachedOrReal(id)
        return ((wikiPage?.instanceOf(PluginTab) && wikiPage.plugin) || wikiPage?.instanceOf(WikiPage)) 
    }
    
    def serverError() {}
    def devError() {}
    def notFound() {
        def originalUri = request.getAttribute('javax.servlet.error.request_uri')
        def parts = originalUri.split('/')
        if(parts.size()==2) {
             def wikiPageId = parts[1].decodeURL()
             if(hasWikiPage(wikiPageId)) {
                 redirect controller: "content", action: "index", id: wikiPageId
                 return false
             }   
        }
        true
    }
}

grails-app/controllers/org/grails/plugin/PendingReleaseController.groovy
package org.grails.plugin

import grails.converters.*

class PendingReleaseController {

    static scaffold = PendingRelease

    def pluginDeployService

    def deploy(Long id) {
        def pr = PendingRelease.get(id)

        if(pr) {
            pluginDeployService.deployRelease(pr)
            flash.message = "Release deployed"
            redirect action:"list"
        }
        else {
            flash.message = "Release not found"
            redirect action:"list"
        }
    }

    /**
     * Returns the status of the given pending release, or a 404 if it doesn't
     * exist.
     */
    def status(String name, String version) {
        def pr = PendingRelease.findByPluginNameAndPluginVersion(name, version)
        if (!pr) {
            def pluginRelease = PluginRelease.where {
                plugin.name == name && releaseVersion == version
            }.get()
            if (pluginRelease) pr = [status: ReleaseStatus.COMPLETED]
        }

        if (pr) {
            withFormat {
                text {
                    render text: pr.status.toString()
                }
                json {
                    render([status: pr.status.toString()] as JSON)
                }
                xml {
                    render contentType: "application/xml", {
                        status pr.status.toString()
                    }
                }
            }
        }
        else {
            response.sendError 404
        }
    }
}

grails-app/controllers/org/grails/plugin/PluginAdminController.groovy
package org.grails.plugin

class PluginAdminController {

	def scaffold = Plugin

    def list() {
        params.max = Math.min(params.max ? params.int('max') : 10, 100)
        [pluginList: Plugin.list(params), pluginTotal: Plugin.count()]
    }

    def search(String q) {
      def max = Math.min(params.max ? params.int('max') : 10, 100)
      def searchResults = Plugin.search(q, [max: max, offset: params.int('offset', 0)])
      render view:"list", model:[pluginList: searchResults.results, pluginTotal:searchResults.total]        
    }

    def show() {
        def plugin = Plugin.get(params.id)
        if (!plugin) {
            flash.message = "Plugin not found"
            redirect(action: "list")
        }
        else {
            [plugin: plugin]
        }
    }

    // One time use data migration action
    def dataSource
    def fixTabs() {
        def sql = new groovy.sql.Sql(dataSource)

        sql.withTransaction {
            sql.eachRow("select * from plugin") { row ->

                def descId = row.description_id
                def installId = row.installation_id
                def faqId = row.faq_id
                def screenshotsId = row.screenshots_id

                def currentId = descId
                def name = row.name

                updateTab(sql, descId, "description", name, row.id )
                updateTab(sql, installId, "installation", name, row.id )
                updateTab(sql, faqId, "faq", name, row.id )
                updateTab(sql, screenshotsId, "screenshots", name, row.id )
            }


        }
        render "Done."
    }

    private updateTab(sql, id, type, pluginName, pluginId) {
        def key = "plugin-$pluginName-$type".toString()
        def current = sql.firstRow("select * from content where class = ? and id = ?", ["org.grails.plugin.PluginTab", id])
        def existing = sql.firstRow("select * from content where class = ? and title = ?", ["org.grails.plugin.PluginTab", key])

        
        if(current.title != key) {
            if(existing) {
                sql.executeUpdate "update plugin set "+type+"_id = ? where id = ?", [existing.id, pluginId]
                sql.executeUpdate "update content set body = ? where id = ?", [current.body, existing.id]
            }
            else {
                sql.executeUpdate "update content set title = ? where class = ? and id = ?", [key, "org.grails.plugin.PluginTab", id]    
            }                    
        }        
    }


    def searchableService
    def update(Long id, Long version) {

        def p = Plugin.get(id)
        println "updating plugin $p"
        if (!p) {
            flash.message = message(code: 'default.not.found.message', args: [message(code: '${domainClass.propertyName}.label', default: 'Plugin'), id])
            redirect(action: "list")
            return
        }

        if (version != null) {
            if (p.version > version) {
                println "VERSION MISMATCH"
                p.errors.rejectValue("version", "default.optimistic.locking.failure",
                          [message(code: '${domainClass.propertyName}.label', default: 'Plugin')] as Object[],
                          "Another user has updated this Plugin while you were editing")
                render(view: "edit", model: [pluginInstance: p])
                return
            }
        }

        bindData(p, params)

        try {
            searchableService.stopMirroring()
            if (!p.save(flush: true)) {
                println "VALIDATION ERRORS ${p.errors}"
                render(view: "edit", model: [pluginInstance: p])
                return
            }
            println "SAVED!"
        }
        finally {
             searchableService.startMirroring()

        }
            flash.message = message(code: 'default.updated.message', args: [message(code: '${domainClass.propertyName}.label', default: 'Plugin'), p.id])
        redirect(action: "show", id: p.id)
    }
}

grails-app/controllers/org/grails/plugin/PluginPendingApprovalController.groovy
package org.grails.plugin

import org.apache.shiro.SecurityUtils
import org.grails.content.GenericApprovalResponse
import org.grails.common.ApprovalStatus

class PluginPendingApprovalController {
    def pluginService
    def genericApprovalResponseService

    def list() {
        params.max = Math.min(params.max ? params.int('max') : 10, 100)
        [
                pluginPendingApprovalList: PluginPendingApproval.list(params),
                pluginPendingApprovalTotal: PluginPendingApproval.count()
        ]
    }

    def show() {

        def pluginPendingApproval = PluginPendingApproval.get(params.id)

        if (pluginPendingApproval) {
            [pluginPendingApproval: pluginPendingApproval]

        } else {
            redirect action: 'list'
        }
    }

    def disposition() {
        def pluginPendingApprovalInstance = PluginPendingApproval.get(params.id)

        def user = pluginPendingApprovalInstance.submittedBy

        def genericApprovalResponse = new GenericApprovalResponse(
                submittedBy: user,
                moderatedBy: request.user,
                whatType: pluginPendingApprovalInstance.class.name,
                whatId: pluginPendingApprovalInstance.id,
                responseText: params.responseText,
                status: ApprovalStatus.valueOf(params.status)
        )

        if (!genericApprovalResponse.hasErrors()
                && genericApprovalResponse.save()
                && user.addToPermissions("plugin:publish:$params.pluginName")
                .addToPermissions("plugin:edit:$params.pluginName")
                .save()
        ) {

            if (genericApprovalResponseService.linkAndfirePendingApproval(genericApprovalResponse)) {
                flash.message = "Response was submitted to ${genericApprovalResponse.submittedBy?.login} (${genericApprovalResponse.submittedBy?.email})"
            }
            else {
                flash.message = "Unable to process the request including sending the email."
            }
        }
        else {
            println genericApprovalResponse.errors?.inspect()
            flash.message = "Unable to save response."
        }
        redirect action: 'show', id: pluginPendingApprovalInstance.id
    }


}

grails-app/controllers/org/grails/plugin/PluginReleaseController.groovy
package org.grails.plugin

class PluginReleaseController {
    static scaffold = true
}

grails-app/controllers/org/grails/plugin/PluginTabController.groovy
package org.grails.plugin


class PluginTabController {
    static scaffold = PluginTab
}

grails-app/views/plugin/_loginBar.gsp
<ul id="loginLinks" class="topLinks nav pills">
    <shiro:isLoggedIn>
        <li><a href="/logout">Logout</a></li>
        <li class="spacing">&nbsp;</li>
        <li class="current-user"><g:link uri="/profile"><b>${user?.login}</b> (${user?.email})</g:link></li>
    </shiro:isLoggedIn>
    <shiro:isNotLoggedIn>
        <li><a href="/login?targetUri=${request.forwardURI}?${request.queryString}" class="login">Login</a></li>
        <li class="spacing">&nbsp;</li>
        <li><a href="/register">Create Account</a></li>
    </shiro:isNotLoggedIn>
</ul> 

grails-app/views/plugin/_pendingPlugin.gsp
<article class="item">
    <header>
        <h3>
            <a href="/plugins/pending/${pluginPendingApprovalInstance?.id}">
                ${pluginPendingApprovalInstance?.name}
                <g:if test="${pluginPendingApprovalInstance?.isNew}">
                    <g:img dir="img/page" file="new.png" />
                </g:if>
            </a>
        </h3>

        <p class="meta">
            version <strong>${pluginPendingApprovalInstance?.versionNumber}</strong>,
            approval status: <strong><common:approvalStatus status="${pluginPendingApprovalInstance?.status}" /></strong>,
            submitted by <a href="#">${pluginPendingApprovalInstance?.submittedBy?.login}</a>
            <prettytime:display date="${pluginPendingApprovalInstance?.dateCreated}"/>
        </p>
    </header>

    <div class="desc">
        <p>${pluginPendingApprovalInstance?.notes}</p>
    </div>
</article>

grails-app/views/plugin/_pluginButtons.gsp
            <p class="buttons">
                <g:if test="${plugin.documentationUrl}">
                    <a href="${plugin.documentationUrl.encodeAsHTML()}" target="_blank" class="btn blueLight doc"><i class="icon-book"></i>&nbsp;Documentation</a>
                </g:if>
                <g:if test="${plugin.scmUrl}">
                    <a href="${plugin.scmUrl.encodeAsHTML()}" target="_blank" class="btn blueLight source"><i class="icon-code"></i>&nbsp;Source</a>
                </g:if>
                <g:if test="${plugin.issuesUrl}">
                    <a href="${plugin.issuesUrl.encodeAsHTML()}" target="_blank" class="btn blueLight issues"><i class="icon-bug"></i>&nbsp;Issues</a>
                </g:if>
            </p>

grails-app/views/plugin/_pluginTags.gsp
<span>Tags:</span>
<span id="plugin-tags-${plugin.id}">
    <g:if test="${plugin.tags.size() > 0}">
        <g:each in="${plugin.tags}" var="tag" status="i"><g:if test="${i > 0}">, </g:if><a href="/plugins/tag/${tag}">${tag}</a></g:each>
    </g:if>
    <g:else>
        /
    </g:else>
</span>

<g:if test="${enableEdit}">
<g:if test="${request.user != null}">
    <a href="#" id="plugin-tag-edit${plugin.id}"><img src="/img/icons/edit-tag.png"  /></a>
</g:if>
<g:else>
    <g:link controller="user" action="login" params="[targetUri:request.forwardURI]"><img src="/img/icons/edit-tag.png"  /></g:link>
</g:else>
<ul id="pluginTags${plugin.id}" data-plugin="${plugin.name}" style="display:none;">
    <g:each in="${plugin.tags}" var="tag"><li data-plugin="${plugin.name}">${tag}</li></g:each>    
</ul>
<asset:script>
    var pluginTags = $('#pluginTags${plugin.id}')
    pluginTags.tagit({
        onTagAdded: onTagAddedFunction,
        onTagRemoved: onTagRemovedFunction,
        onTagClicked:onTagClickFunction,
        availableTags: tags
        
    });

    <g:if test="${request.user != null}">
        $('#plugin-tag-edit${plugin.id}').click(function() {
            $('#pluginTags${plugin.id} input').focus();
            $('#plugin-tags-${plugin.id}').hide();
            $('#pluginTags${plugin.id}').show();
            return false;
        });
        var timer;
        $('#pluginTags${plugin.id} input').blur(function(){
            $('#pluginTags${plugin.id} input').data("focus", "false");
            if (timer)
                clearTimeout(timer);
            timer = setInterval(function(){
                if ($('#pluginTags${plugin.id} input').data("focus") == "false") {
                    $('#plugin-tag-edit${plugin.id}').show();
                    $('#plugin-tags-${plugin.id}').show();
                    $('#pluginTags${plugin.id}').hide();
                    if ($("#pluginTags${plugin.id} li").length == 0) {
                        $('#plugin-tags-${plugin.id}').text("/");
                    } else {
                        var str = $("#pluginTags${plugin.id} li .tagit-label").map(function() {
                            return "<a href='/plugins/tag/" + $(this).text() + "'>" + $(this).text() + "</a>";
                        }).get().join(', ');
                        $('#plugin-tags-${plugin.id}').html(str);
                    }
                }
                clearTimeout(timer);
            },400);
        }).focus(function() {
            $('#pluginTags${plugin.id} input').data("focus", "true");
            $('#plugin-tag-edit${plugin.id}').hide();
            $('#plugin-tags-${plugin.id}').hide();
            $('#pluginTags${plugin.id}').show();
        });

    </g:if>
</asset:script>
</g:if>

grails-app/views/plugin/_searchBar.gsp
<form id="plugin-search" class="search" action="/plugins/search" name="plugin-search" method="GET">
    <input type="text" id="q" name="q" value="${params.q?.encodeAsHTML()}" placeholder="Search for a plugin"/>
    <a href="#" id="search-button" class="btn btn-search">
        <i class="icon-search icon-white"></i>
    </a>
</form>

grails-app/views/plugin/_sideNav.gsp
<div class="aside">
    <aside class="filters">
        <h3>Filters<g:if test="${activeFilter != 'all'}">&nbsp;&nbsp;&nbsp;<a style="font-size: smaller;" href="/plugins?filter=all">clear filter</a></g:if></h3>
        <ul>
            <li <g:if test="${activeFilter == 'all'}">class="active"</g:if>>
                <a href="/plugins?filter=all">
                    <g:img dir="img/icons" file="plugin.png" />
                    All Grails 1 & 2 Plugins
                </a>
            </li>            
            <li <g:if test="${activeFilter == 'featured'}">class="active"</g:if>><a href="/plugins?filter=featured"><g:img dir="img/plugin" file="featured.png" /> Featured</a></li>
            <li <g:if test="${activeFilter == 'installed'}">class="active"</g:if>><a href="/plugins?filter=installed"><g:img dir="img/plugin" file="topInstalled.png" /> Top Installed</a></li>
            <li <g:if test="${activeFilter == 'popular'}">class="active"</g:if>><a href="/plugins?filter=popular"><g:img dir="img" file="star-on.png" /> Popular</a></li>
            <li <g:if test="${activeFilter == 'recentlyUpdated'}">class="active"</g:if>><a href="/plugins?filter=recentlyUpdated"><g:img dir="img/plugin" file="recentlyUpdated.png" /> Recently Updated</a></li>
            <li <g:if test="${activeFilter == 'newest'}">class="active"</g:if>><a href="/plugins?filter=newest"><g:img dir="img/plugin" file="newest.png" /> Newest</a></li>
            <li <g:if test="${activeFilter == 'supported'}">class="active"</g:if>><a href="/plugins?filter=supported"><g:img dir="img/plugin" file="supported.png" /> Plugin Collection</a></li>
            <li class="last">
                <a href="/plugins/pending">
                    <g:img dir="img/icons" file="pending.png"/>
                    Pending Plugins
                </a>
            </li>                
        </ul>
    </aside>

    <aside class="tags">
        <h3>Popular tags<g:if test="${activeTag}">&nbsp;&nbsp;&nbsp;<a style="font-size: smaller;" href="/plugins?filter=all">clear tag</a></g:if></h3>
        <ul>
            <g:each in="${tags}" var="tag" status="i">
                <li class="
                    <g:if test="${activeTag == tag}"> active</g:if>
                    <g:if test="${i == tags.size() - 1}"> last</g:if>
                "><a href="/plugins/tag/${tag}">${tag.capitalize()}</a></li>
            </g:each>
        </ul>
    </aside>

</div>

grails-app/views/plugin/_tagSetup.gsp
<asset:script>
    var tagsInitialized = false;
    var tags = [
        ${allTags.collect { "\"$it\""}.join(',')}
    ]

    var onTagAddedFunction =  function(event, tag) {
        if(${request.user == null} && tagsInitialized) {
            window.location = "${createLink(controller:'user', action:'login')}";
        }
        else if(tagsInitialized){
            var link = "${createLink(action:"addTag")}";
            var label = pluginTags.tagit('tagLabel', tag)
            var plugin = $("#" + this.id).data("plugin")
            $.ajax({url:link, type:"POST",data: {tag: label, id: plugin}})
        }
    }
    var onTagRemovedFunction =  function(event, tag) {
        if(${request.user == null} && tagsInitialized) {
            window.location = "${createLink(controller:'user', action:'login')}";
        }
        else if(tagsInitialized){
            var link = "${createLink(action:"removeTag")}";
            var label = pluginTags.tagit('tagLabel', tag)
            var plugin = $("#" + this.id).data("plugin")
            $.ajax({url:link, type:"POST",data: {tag: label, id: plugin}})

        }
    }    
    var onTagClickFunction = function(event, tag) {
            var label = pluginTags.tagit('tagLabel', tag)
            var link = "/plugins/tag/" + label;

            window.location = link;
    }     
</asset:script>

grails-app/views/plugin/pendingPlugins.gsp
<head>
    <meta content="masterv2" name="layout"/>
    <title>Pending Grails Plugins</title>
    <asset:stylesheet src="plugin"/>
    <asset:javascript src="plugin"/>
</head>

<body>

<div id="content" class="content-aside" role="main">

    <div class="aside">
        <g:render template="sideSubmission"/>
    </div>

    <section id="main" class="items">
        <g:if test="${pluginPendingApprovalTotal == 0}">
            <div class="alert alert-block">
                <p><strong>Woot!</strong><br />
                We must really be on top of things if we have no pending plugin approvals.<br />
                    To submit your plugin for approval, go to the <a href="/plugins/submitPlugin">Submit a Plugin</a> page.</p>
            </div>
        </g:if>
        <g:render template="pendingPlugin" collection="${pluginPendingApprovalList}"
                  var="pluginPendingApprovalInstance"/>
    </section>

</div>

</body>

grails-app/views/plugin/showPendingPlugin.gsp
<head>
    <meta content="masterv2" name="layout"/>
    <title>Pending Grails Plugin: ${pluginPendingApprovalInstance?.name.encodeAsHTML()}</title>
    <asset:stylesheet src="plugin"/>
    <asset:javascript src="plugin"/>
</head>

<body>

<div id="content" class="content-aside" role="main">

    <div class="aside">
        <g:render template="sideSubmission"/>
    </div>

    <section id="main" class="items">
        <article class="item">
            <header>
                <h3 class="single">${pluginPendingApprovalInstance?.name}</h3>

                <p class="meta">
                    <strong>version:</strong> ${pluginPendingApprovalInstance?.versionNumber}
                    <br/>
                    <strong>approval status:</strong> <common:approvalStatus status="${pluginPendingApprovalInstance?.status}" />
                    <br/>
                    <strong>source:</strong> <a href="${pluginPendingApprovalInstance?.scmUrl}">${pluginPendingApprovalInstance?.scmUrl}</a>
                    <br/>                    
                    submitted by <a href="#">${pluginPendingApprovalInstance?.submittedBy?.login}</a>
                    <prettytime:display date="${pluginPendingApprovalInstance?.dateCreated}"/>
                </p>
            </header>

            <div class="desc">
                <p>${pluginPendingApprovalInstance?.notes}</p>
            </div>
            <div class="disqus-container">
                <disqus:comments bean="${pluginPendingApprovalInstance}"  url="${createLink(uri:request.forwardURI, absolute:true)}"/>
            </div>
        </article>
        <g:if test="${pluginPendingApprovalInstance?.isNew}">
            <span class="status status-new">New</span>
        </g:if>
    </section>
</div>

</body>

grails-app/views/plugin/submissionReceived.gsp
<head>
    <meta content="masterv2" name="layout"/>
    <title>Grails Plugin Submitted for Approval</title>
    <asset:stylesheet src="plugin"/>
    <asset:javascript src="plugin"/>
</head>

<body>

<div id="content" class="content-aside-2" role="main">

    <div class="aside">
        <g:render template="sideSubmission" />
    </div>

    <section id="main">

        <article>
            <h3>Submit Plugin for Approval</h3>

            <g:if test="${flash.message}">
                <div class="alert alert-info">${flash.message}</div>
            </g:if>

            <p>Thank you for submitting your plugin. We will get back to you within 24 hours with either an approval, or
            a rejection with an explanation.</p>

        </article>
    </section>

</div>

</body>

grails-app/views/plugin/submitPlugin.gsp
<head>
    <meta content="masterv2" name="layout"/>
    <title>Submit a Grails Plugin for Approval</title>
    <asset:stylesheet src="plugin"/>
    <asset:javascript src="plugin"/>
</head>

<body>

<div id="content" class="content-aside" role="main">

    <div class="aside">
        <g:render template="sideSubmission"/>
    </div>

    <section id="main" class="plugins">

        <article>
            <h2>Submit Plugin for Approval</h2>

            <g:if test="${flash.message}">
                <div class="alert alert-${pluginPendingApproval.errors.errorCount > 0 ? 'error' : 'info'}">${flash.message}</div>
            </g:if>

            <g:form action="submitPlugin" class="content-form padding-top">

                <g:hiddenField name="status" value="${pluginPendingApproval.status}"/>

                <div class="control-group ${hasErrors(bean: pluginPendingApproval, field: 'name', 'error')}">
                    <label for="name">Plugin Name <small>(whatever you passed to the create-plugin command)</small></label>

                    <div class="col-sm-10">
                        <g:textField class="form-control input-fullsize" name="name" value="${params.name}" required="required" />
                        <g:if test="${pluginPendingApproval.errors.getFieldErrorCount('name') > 0}">
                            <p class="error-block">${pluginPendingApproval.errors.getFieldError('name').defaultMessage}</p>
                        </g:if>
                    </div>
                </div>

                <div class="control-group ${hasErrors(bean: pluginPendingApproval, field: 'versionNumber', 'error')}">
                    <label for="versionNumber">Version Number <small>(example: 0.0.1)</small></label>
                    <div class="col-sm-10">
                        <g:textField class="form-control input-fullsize" name="versionNumber" value="${params.versionNumber}" required="required" />
                        <g:if test="${pluginPendingApproval.errors.getFieldErrorCount('versionNumber') > 0}">
                            <p class="help-block">${pluginPendingApproval.errors.getFieldError('versionNumber').defaultMessage}</p>
                        </g:if>
                        <p class="help-block">This is important indicating versions if you need to re-submit plugins</p>
                    </div>
                </div>

                <div class="control-group ${hasErrors(bean: pluginPendingApproval, field: 'scmUrl', 'error')}">
                    <label for="scmUrl">Repository URL <small>(for example, http://www.github.com/grails/grails-core)</small></label>
                    <div class="col-sm-10">
                        <g:textField class="form-control input-fullsize" name="scmUrl" value="${params.scmUrl}" required="required" />
                        <g:if test="${pluginPendingApproval.errors.getFieldErrorCount('scmUrl') > 0}">
                            <p class="error-block">${pluginPendingApproval.errors.getFieldError('scmUrl').defaultMessage}</p>
                        </g:if>
                    </div>
                </div>

                <div class="control-group">
                    <label for="notes">Plugin Description</label>

                    <div class="col-sm-10">
                        <g:textArea class="form-control input-fullsize" rows="8" cols="60" name="notes" value="${params.notes}" required="required" ></g:textArea>
                    </div>
                </div>

                <p>
                    <em>Please note that in order for a plugin to be approved, you must make sure that the plugin is well
                    documented, which includes a full description and usage.</em>
                </p>

                <div class="form-group"><div class="col-sm-offset-2 col-sm-10">
                    <g:submitButton name="submit" value="Submit for Approval" class="btn"/>
                </div></div>

            </g:form>
        </article>

    </section>

</div>

</body>